// arduinoportsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "arduinoports.h"
#include "arduinoportsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "SerialGate.h"

/////////////////////////////////////////////////////////////////////////////
// CArduinoportsDlg dialog

CArduinoportsDlg::CArduinoportsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArduinoportsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArduinoportsDlg)
	m_COM_port = _T("");
	m_0 = FALSE;
	m_1 = FALSE;
	m_10 = FALSE;
	m_11 = FALSE;
	m_12 = FALSE;
	m_13 = FALSE;
	m_14 = FALSE;
	m_15 = FALSE;
	m_16 = FALSE;
	m_17 = FALSE;
	m_18 = FALSE;
	m_19 = FALSE;
	m_2 = FALSE;
	m_3 = FALSE;
	m_4 = FALSE;
	m_5 = FALSE;
	m_6 = FALSE;
	m_7 = FALSE;
	m_8 = FALSE;
	m_9 = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArduinoportsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArduinoportsDlg)
	DDX_Text(pDX, IDC_EDIT_COM_PORT, m_COM_port);
	DDX_Check(pDX, IDC_0, m_0);
	DDX_Check(pDX, IDC_1, m_1);
	DDX_Check(pDX, IDC_10, m_10);
	DDX_Check(pDX, IDC_11, m_11);
	DDX_Check(pDX, IDC_12, m_12);
	DDX_Check(pDX, IDC_13, m_13);
	DDX_Check(pDX, IDC_14, m_14);
	DDX_Check(pDX, IDC_15, m_15);
	DDX_Check(pDX, IDC_16, m_16);
	DDX_Check(pDX, IDC_17, m_17);
	DDX_Check(pDX, IDC_18, m_18);
	DDX_Check(pDX, IDC_19, m_19);
	DDX_Check(pDX, IDC_2, m_2);
	DDX_Check(pDX, IDC_3, m_3);
	DDX_Check(pDX, IDC_4, m_4);
	DDX_Check(pDX, IDC_5, m_5);
	DDX_Check(pDX, IDC_6, m_6);
	DDX_Check(pDX, IDC_7, m_7);
	DDX_Check(pDX, IDC_8, m_8);
	DDX_Check(pDX, IDC_9, m_9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CArduinoportsDlg, CDialog)
	//{{AFX_MSG_MAP(CArduinoportsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_EDIT_COM_PORT, OnChangeEditComPort)
	ON_BN_CLICKED(IDC_0, On0)
	ON_BN_CLICKED(IDC_1, On1)
	ON_BN_CLICKED(IDC_10, On10)
	ON_BN_CLICKED(IDC_11, On11)
	ON_BN_CLICKED(IDC_12, On12)
	ON_BN_CLICKED(IDC_13, On13)
	ON_BN_CLICKED(IDC_14, On14)
	ON_BN_CLICKED(IDC_15, On15)
	ON_BN_CLICKED(IDC_16, On16)
	ON_BN_CLICKED(IDC_17, On17)
	ON_BN_CLICKED(IDC_18, On18)
	ON_BN_CLICKED(IDC_19, On19)
	ON_BN_CLICKED(IDC_2, On2)
	ON_BN_CLICKED(IDC_3, On3)
	ON_BN_CLICKED(IDC_4, On4)
	ON_BN_CLICKED(IDC_5, On5)
	ON_BN_CLICKED(IDC_6, On6)
	ON_BN_CLICKED(IDC_7, On7)
	ON_BN_CLICKED(IDC_8, On8)
	ON_BN_CLICKED(IDC_9, On9)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArduinoportsDlg message handlers

BOOL CArduinoportsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_COM_port="16";
	//MessageBox(m_COM_port,NULL,MB_OK);
	UpdateData(FALSE); 
	state=false;
	open_port();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArduinoportsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArduinoportsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CArduinoportsDlg::OnChangeEditComPort() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	////    ,
	////(     )
	UpdateData(TRUE);
	sg.Close();
	state=false;
	open_port();
}

void CArduinoportsDlg::open_port()
{
	bool b = sg.Open(atoi(m_COM_port),9600);
	if(!b)
	{
		MessageBox("Error: open COM-port",m_COM_port,MB_OK);
		state=false;
	}
	else
	{
		state=true;
	}

}

void CArduinoportsDlg::On0() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_0)
	{
		sg.Send("00H",3);
	}
	else
	{
		sg.Send("00L",3);
	}
}

void CArduinoportsDlg::On1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_1)
	{
		sg.Send("01H",3);
	}
	else
	{
		sg.Send("01L",3);
	}
}

void CArduinoportsDlg::On10() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_10)
	{
		sg.Send("10H",3);
	}
	else
	{
		sg.Send("10L",3);
	}
}

void CArduinoportsDlg::On11() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_11)
	{
		sg.Send("11H",3);
	}
	else
	{
		sg.Send("11L",3);
	}
}

void CArduinoportsDlg::On12() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_12)
	{
		sg.Send("12H",3);
	}
	else
	{
		sg.Send("12L",3);
	}
}

void CArduinoportsDlg::On13() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_13)
	{
		sg.Send("13H",3);
	}
	else
	{
		sg.Send("13L",3);
	}
}

void CArduinoportsDlg::On14() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_14)
	{
		sg.Send("14H",3);
	}
	else
	{
		sg.Send("14L",3);
	}
}

void CArduinoportsDlg::On15() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_15)
	{
		sg.Send("15H",3);
	}
	else
	{
		sg.Send("15L",3);
	}
}

void CArduinoportsDlg::On16() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_16)
	{
		sg.Send("16H",3);
	}
	else
	{
		sg.Send("16L",3);
	}
}

void CArduinoportsDlg::On17() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_17)
	{
		sg.Send("17H",3);
	}
	else
	{
		sg.Send("17L",3);
	}
}

void CArduinoportsDlg::On18() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_18)
	{
		sg.Send("18H",3);
	}
	else
	{
		sg.Send("18L",3);
	}
}

void CArduinoportsDlg::On19() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_19)
	{
		sg.Send("19H",3);
	}
	else
	{
		sg.Send("19L",3);
	}
}

void CArduinoportsDlg::On2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_2)
	{
		sg.Send("02H",3);
	}
	else
	{
		sg.Send("02L",3);
	}
}

void CArduinoportsDlg::On3() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_3)
	{
		sg.Send("03H",3);
	}
	else
	{
		sg.Send("03L",3);
	}
}

void CArduinoportsDlg::On4() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_4)
	{
		sg.Send("04H",3);
	}
	else
	{
		sg.Send("04L",3);
	}
}

void CArduinoportsDlg::On5() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_5)
	{
		sg.Send("05H",3);
	}
	else
	{
		sg.Send("05L",3);
	}
}

void CArduinoportsDlg::On6() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_6)
	{
		sg.Send("06H",3);
	}
	else
	{
		sg.Send("06L",3);
	}
}

void CArduinoportsDlg::On7() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_7)
	{
		sg.Send("07H",3);
	}
	else
	{
		sg.Send("07L",3);
	}
}

void CArduinoportsDlg::On8() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_8)
	{
		sg.Send("08H",3);
	}
	else
	{
		sg.Send("08L",3);
	}
}

void CArduinoportsDlg::On9() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_9)
	{
		sg.Send("09H",3);
	}
	else
	{
		sg.Send("09L",3);
	}
}
